#
# spec file for package python-restkit
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           python-restkit
Version:        4.2.2
Release:        4.2
Summary:        Python REST kit
License:        MIT
Group:          Development/Languages/Python
Url:            http://benoitc.github.com/restkit
Source:         http://pypi.python.org/packages/source/r/restkit/restkit-%{version}.tar.gz
BuildRequires:  python-Sphinx
BuildRequires:  python-WebOb
BuildRequires:  python-devel
BuildRequires:  python-http-parser
BuildRequires:  python-nose
BuildRequires:  python-setuptools
BuildRequires:  python-socketpool
Requires:       python-WebOb
Requires:       python-http-parser
Requires:       python-socketpool
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?suse_version} && 0%{?suse_version} <= 1110
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%else
BuildArch:      noarch
%endif

%description
Restkit is an HTTP resource kit for Python. It allows you to easily access to
HTTP resource and build objects around it. It's the base of couchdbkit, a
Python CouchDB framework.

Restkit is a full HTTP client using pure socket calls and its own HTTP parser.
It's not based on httplib or urllib2.

%prep
%setup -q -n restkit-%{version}

%build
python setup.py build
cd doc
make html && rm -r _build/html/.buildinfo

%install
python setup.py install --prefix=%{_prefix} --root=%{buildroot}
rm -rf %{buildroot}%{_prefix}/restkit # Remove wrongly installed documentation
rm -rf %{buildroot}%{python_sitelib}/tests # Remove global "tests" module

# Fail for instance
#%check
#python setup.py test

%files
%defattr(-,root,root,-)
%doc LICENSE NOTICE README.rst THANKS TODO.txt examples doc/_build/html
%{_bindir}/restcli
%{python_sitelib}/*

%changelog
* Sun Nov 24 2013 p.drouand@gmail.com
- Update to version 4.2.2
  + ChangeLog hasn't been updated for this version
- Generate documentation with Sphinx and add it in package
* Mon Oct 28 2013 speilicke@suse.com
- Don't install global "tests" module into python_sitelib
* Thu Oct 24 2013 speilicke@suse.com
- Require python-setuptools instead of distribute (upstreams merged)
* Sat Feb  9 2013 p.drouand@gmail.com
- Update to version 4.2.1:
  * No changelog available
* Thu Jan 24 2013 p.drouand@gmail.com
- Update to version 4.2.0:
  * No changelog available
* Mon Feb 13 2012 jfunk@funktronics.ca
- Update to version 4.1.2:
  * set content-length if provided
  * Fix bad http-parser version requirement
* Thu Feb  2 2012 saschpe@suse.de
- Fix version and add requirement on python-socketpool
* Tue Jan 31 2012 saschpe@suse.de
- Simplified macro usage
- Update to version 4.1.1:
  * fix connection reusing. When connection is closed or an EPIPE/EAGAIN error happen, we now retry it.
  * fix wgsi_proxy contrib
  * fix examples
- Changes from version 3.0.0:
  * Replace the socket pool by socketpool improve connection handling and better management of gevent & eventlet.
  * Fix NoMoreData issue
  * Fix SSL connections
  * multipart forms: quote is now configurable & flush size cache
* Thu Dec  8 2011 jfunk@funktronics.ca
- Update to 3.3.2
  - add support for multivalue field in multipart
  - form_encode can now accept arbitrary items
  - fix proxy handling in client
* Fri Sep 23 2011 saschpe@suse.de
- Update to 3.3.1:
  * 
* Mon Jun 20 2011 jfunk@funktronics.ca
- Update to 3.3.0
  - New HTTP parser, using python http-parser in C based on http-parser from
    Ryan Dahl
  - Fix UnboundLocalError
  - Sync oauth with last python-oauth2 (fix POST & encoding issues)
  - Improve sending
- 3.2.1
  - Fix sending on linux
* Thu Mar 10 2011 jfunk@funktronics.ca
- Update to 3.2.0
  - Some deep rewrite of the client. Requests and Connections are now
    maintened in their own instances, so we don't rely on client instance to
    close or release the connection. Also we don't pass local variable to
    handle a request. At the end each requests are more isolated and we are
    fully threadsafe.
  - Improve error report.
  - Handle case where the connection is closed but the OS still accept
    sending. From the man: "When the message does not fit into the send buffer
    of the socket, send() normally blocks, unless the socket has been placed
    in nonblocking I/O mode.""" . Spotted by loftus on irc. Thanks.
- Breaking changes
  - Rewrite filters handling. We now pass a request instance to the on_request
    filters. If a request filter return a response, we stop to perform here.
    response filters accept now the response and request instances as
    arguments. There is no more on_connect filters (it was a bad idea)
  - Proxy support. Proxies are now supported by passing the argument
    "use_proxy=True" to client, request and resources objects.
* Thu Feb  3 2011 jfunk@funktronics.ca
- Update to 3.0.1
  - New Connection management: Better concurrency handling and idle
    connections are now closed after a time
  - Improved Client
  - Fix redirect
  - Better error handling
  - Timeout can now be set on each request.
  - Major refactoring. consolidation of some module, ease the HTTP parser code
  - Fix timeout errors
* Tue Jan 25 2011 saschpe@suse.de
- Update to 2.3.3
* Wed Mar 17 2010 jfunk@funktronics.ca
- Update to 1.2.1
* Sat Jan  9 2010 jfunk@funktronics.ca
- Update to 0.9.3
  - fix distribute line
  - don't release connection if it need to be closed.
  - add tests with big upload. and multiple Post serialised.
* Mon Dec 14 2009 jfunk@funktronics.ca
- Update to 0.9.2
  - Make sure restkit works with multiprocess. fix eventlet.
* Tue Dec  8 2009 jfunk@funktronics.ca
- Update to 0.9.1
  - fix ResponseStream. buffer read
* Mon Dec  7 2009 jfunk@funktronics.ca
- Update to 0.9
  - New response object. Now a `restkit.Resource` and `restkit.RestClient`
    return an  `restkit.HTTPResponse` instance and no longer an unicode. The
    HTTPResponse allow you to get all in one the headers, the body and allow
    you to stream it by using the property `body_file` which give you a
    `fileobject`
  - Fix in spool class. Reuse spool across all objects. It doesn't use Queue
    anymore since collection.deque is already threadsafe
  - Change in WebOb helper. Now you have to use
    `restkit.ext.webob_helper.wrap_exceptions` to use WebOb extensions.
  - Fix eventlet extension.
* Thu Nov 12 2009 jfunk@funktronics.ca
- Remove false and conflicting runtime requirement
* Tue Nov 10 2009 jfunk@funktronics.ca
- Initial release
